> For the complete documentation index, see [llms.txt](https://docs.gooddollar.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.gooddollar.org/for-developers/core-contracts/nameservice.md).

# NameService

### Events

#### AddressChanged

Emitted when address under the name was changed.

<table><thead><tr><th width="389.63805195347794">Parameter name</th><th>Annotation</th></tr></thead><tbody><tr><td>name</td><td>Name of the address.</td></tr><tr><td>addr</td><td>The address itself.</td></tr></tbody></table>

```
event AddressChanged(string name, address addr);
```

### setAddress

The function that sets the new address under the name.

<table><thead><tr><th width="301.8711599216471">Parameter name</th><th>Annotation</th></tr></thead><tbody><tr><td>name</td><td>The name of an address.</td></tr><tr><td>addr</td><td>The new address itself.</td></tr></tbody></table>

Can only be called by the Avatar.

```
function setAddress(string memory name, address addr) external;
```

### setAddresses

The function that sets the new group of addresses under the names.

<table><thead><tr><th width="301.8711599216471">Parameter name</th><th>Annotation</th></tr></thead><tbody><tr><td>hash</td><td>The array of keccak256's of names.</td></tr><tr><td>addrs</td><td>The new addresses themselfs.</td></tr></tbody></table>

Can only be called by the Avatar.

```
function setAddresses(bytes32[] calldata hash, address[] calldata addrs) external;
```

### getAddress

The function that gets the address under the name.

<table><thead><tr><th width="301.8711599216471">Parameter name</th><th>Annotation</th></tr></thead><tbody><tr><td>name</td><td>The name of an address.</td></tr></tbody></table>

Returns: the address under the given name.

```
function getAddress(string memory name) external view returns (address);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.gooddollar.org/for-developers/core-contracts/nameservice.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
